YAML form
---------

Commands
--------

Reinstall YAML form module.

     drush yamlform-purge --all -y; drush pmu -y yamlform_test; drush pmu -y  yamlform; drush en -y yamlform; drush en -y yamlform_test; drush cr;

Create test roles and users.

    drush role-add-perm anonymous 'access yamlform'

    drush role-create developer
    drush role-add-perm developer 'view the administration theme,access toolbar,access administration pages,access content overview,administer yamlform,administer blocks,administer nodes'
    drush user-create developer --password="developer"
    drush user-add-role developer developer
    
    drush role-create admin
    drush role-add-perm admin 'view the administration theme,access toolbar,access administration pages,access content overview,administer yamlform submission'
    drush user-create admin --password="admin"
    drush user-add-role admin admin

Tag release

    git tag 8.x-1.0-unstable2
    git push --tags
    git push origin tag 8.x-1.0-unstable2

Tidy YAML file

    drush yamlform-tidy yamlform; drush yamlform-tidy yamlform_test;
    
PHP 5.4 Short Array Syntax Converter

    wget https://raw.githubusercontent.com/thomasbachem/php-short-array-syntax-converter/master/convert.php
    find . -name "*.install" -exec php "convert.php" -w "{}" \;
    find . -name "*.module" -exec php "convert.php" -w "{}" \;
    find . -name "*.php" -exec php "convert.php" -w "{}" \;
    find . -name "*.inc" -exec php "convert.php" -w "{}" \;
    rm convert.php

    
Todo
----

- Additional test coverage
- Fix minor issues in existing tests. (ie TODO:)
- Input specific tests.
    - Entity autocomplete
    - Managed file
    - Dates

    
Questions
---------

- Should submitted values be casted to datatype?  
 For example, should number inputs be casted to integers.

- Should empty values be hidden by default?

- Should we support private file uploads?  
  If a YAML form is going to actually receive 10000+ submissions that will need 
  to be regularly exported, shouldn't the submission just be posted to the 
  destination application, via a web service, and bypass storing the submission 
  data in Drupal. 

- What global settings should be copied should be copied from the Webform.module.

- How should handlers deal with their global settings?


Roadmap
-------

## Alpha 1

- YamlForm entity
- YamlFormSubmission entity
- YamlFormOptions entity
- YamlFormHandler plugin
- EmailYamlFormHandler
- Prepopulate
- Tokens
- Preview
- URL aliases
    
## Phase 2 (after stable release)

- Advanced Views integration
- Advanced export functionality
  - Date range filter, Last sid, etc...
  - Date range filter, Last sid, etc...
  - Support for bulk (10000+) export using batch processing.
- Wizard
- Drafts

- Custom elements (via yamlform_elements or contrib modules)
  - select_other
  - radios_other
  - checkboxes_other
  - emails
  - email_confirm
  - credit_card
  - yaml_code
  - xml_code
  - html_code
  - autocomplete
  - chosen
  - select2


Features to be handled via YamlFormHandler plugin
-------------------------------------------------

General

- Multistep/Paging/Wizard
- Throttling
- Advanced Access Controls
- Email
- SMS

Specific

- Captcha
- Honeypot
- Payment


Testing
-------

## YAML form test module (yamlform_test) 

The YAML form test module (yamlform_test) includes feature specific and working 
examples for all functionality, setting, customizations, etc...

Make sure to allow the YAML form test module to be installed.

    # Add the below setting to you settings.php file.
    $settings['extension_discovery_scan_tests'] = FALSe;


## PHPUnit

PHPUnit tests needs to be run individual if this module is place in a 
modules sub-directory (ie module/contrib or modules/sandbox).
 
- [/core/phpunit.xml.dist only finds top-level contrib modules](https://www.drupal.org/node/2499239)

If the above patch is applied or this module is in modules/yamlform. 

This command will execute all PHPUnit tests for the YamlForm module

    cd core
    php ../vendor/phpunit/phpunit/phpunit --group YamlFormUnit

The below commands can be used to execute each individual PHPUnit test.

    cd core
    php ../vendor/phpunit/phpunit/phpunit ../modules/sandbox/yamlform/tests/src/Unit/YamlFormTidyTest.php
    php ../vendor/phpunit/phpunit/phpunit ../modules/sandbox/yamlform/tests/src/Unit/YamlFormHelperTest.php
    php ../vendor/phpunit/phpunit/phpunit ../modules/sandbox/yamlform/tests/src/Unit/YamlFormOptionsHelperTest.php

Code Sources and Design Patterns
--------------------------------

Below is just a reference to where most of the code snippets and/or 
design pattern were taken from to build this module.
 
- UI/Naming convention: Webform module (Copied)
- YamlForm to YamlFormSubmission bundle: Vocabulary to Term entities
- YamlFormSubmission entity_type and entity_id: Comment entity
- YamlFormSubmission preview: CommentForm
- YamlFormHandler plugin: ImageEffect


Known Issues
------------

- Unable to tidy the bulk export of YamlForm and YamlFormOptions config files 
  because Drupal's Yaml utility is not a service. 
  See: https://www.drupal.org/node/1920902
      
  
Converting README.md to HTML for Drupal.org
-------------------------------------------

- [Convert Markdown to HTML](http://daringfireball.net/projects/markdown/dingus)
- [Tidy HTML](https://infohound.net/tidy/)
    - No indent
    - No wrap   
- Manually cleanup
    - Remove `<html>` tags.
    - Remove 'Contents of this file'.
    - Update example code and wrap in `<pre>` tag.
- [Update project page](https://www.drupal.org/node/2640714/edit)
    - Preview 
    - Save
