<?php

/**
 * @file
 * Definition of Drupal\yamlform\Access\YamlFormAccess.
 */

namespace Drupal\yamlform\Access;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Session\AccountInterface;

/**
 * Defines the custom access control handler for the YAML form entities.
 */
class YamlFormAccess {

  /**
   * Check whether the user has 'administer yamlform' or 'administer yamlform submission' permission.
   *
   * @param \Drupal\Core\Session\AccountInterface $account
   *   Run access checks for this account.
   *
   * @return \Drupal\Core\Access\AccessResultInterface
   *   The access result.
   */
  static public function checkAdminAccess(AccountInterface $account) {
    return ($account->hasPermission('administer yamlform') || $account->hasPermission('administer yamlform submission')) ? AccessResult::allowed() : AccessResult::forbidden();
  }

}
