<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\Color.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\yamlform\YamlFormElementBase;

/**
 * Provides a 'color' element.
 *
 * @YamlFormElement(
 *   id = "color",
 *   label = @Translation("Color"),
 *   description = @Translation("Handles displaying a color element.")
 * )
 */
class Color extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function formatHtml(array &$element, $value) {
    return $this->t('<span class="yamlform-view-color" style="background-color:@color"></span> @color', ['@color' => $value]);
  }

}
