<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\Email.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\yamlform\YamlFormElementBase;

/**
 * Provides a 'email' element.
 *
 * @YamlFormElement(
 *   id = "email",
 *   label = @Translation("Email"),
 *   description = @Translation("Handles displaying of an email address element.")
 * )
 */
class Email extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function formatHtml(array &$element, $value) {
    return $this->t('<a href="mailto:@email">@email</a>', ['@email' => $value]);
  }

}
