<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\LanguageSelect.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\Component\Render\FormattableMarkup;
use Drupal\yamlform\YamlFormElementBase;

/**
 * Provides a 'language_select' element.
 *
 * @YamlFormElement(
 *   id = "language_select",
 *   label = @Translation("Language select"),
 *   description = @Translation("Handles displaying of a language select element.")
 * )
 */
class LanguageSelect extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function formatText(array &$element, $value) {
    $language = \Drupal::languageManager()->getLanguage($value);
    return new FormattableMarkup('@language (@langcode)', ['@language' => $language->getName(), '@langcode' => $language->getId()]);
  }

}
