<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\Telephone.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\yamlform\YamlFormElementBase;

/**
 * Provides a 'tel' element.
 *
 * @YamlFormElement(
 *   id = "tel",
 *   label = @Translation("Telephone"),
 *   description = @Translation("Handles displaying of a telephone element.")
 * )
 */
class Telephone extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function formatHtml(array &$element, $value) {
    return $this->t('<a href="tel:@tel">@tel</a>', ['@tel' => $value]);
  }

}
