<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\TextFormat.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\yamlform\YamlFormElementBase;

/**
 * Provides a 'text_format' element.
 *
 * @YamlFormElement(
 *   id = "text_format",
 *   label = @Translation("TextFormat"),
 *   description = @Translation("Handles normalizing and displaying of a text format element.")
 * )
 */
class TextFormat extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function setDefaultValue(array &$element, $default_value) {
    if (is_array($element['#default_value'])) {
      $element['#format'] = $element['#default_value']['format'];
      $element['#default_value'] = $element['#default_value']['value'];
    }
  }

  /**
   * {@inheritdoc}
   */
  public function formatText(array &$element, $value) {
    return check_markup($value['value'], $value['format']);
  }

}
