<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\Textarea.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\Component\Utility\Html;
use Drupal\yamlform\YamlFormElementBase;

/**
 * Provides a 'textarea' element.
 *
 * @YamlFormElement(
 *   id = "textarea",
 *   label = @Translation("Textarea"),
 *   description = @Translation("Handles displaying of a text area element.")
 * )
 */
class Textarea extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function formatHtml(array &$element, $value) {
    return _filter_autop(Html::escape($value));
  }

}
