<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\Url.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\yamlform\YamlFormElementBase;

/**
 * Provides a 'url' element.
 *
 * @YamlFormElement(
 *   id = "url",
 *   label = @Translation("Url"),
 *   description = @Translation("Handles displaying of a URL element.")
 * )
 */
class Url extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function formatHtml(array &$element, $value) {
    return $this->t('<a href=":url">@url</a>', [':url' => $value, '@url' => $value]);
  }

}
