<?php

/**
 * @file
 * Definition of Drupal\yamlform\test\YamlFormNodeTest.
 */

namespace Drupal\yamlform\Tests;

/**
 * Tests for YAML form node.
 *
 * @group YamlForm
 */
class YamlFormNodeTest extends YamlFormTestBase {

  /**
   * Tests YAML form node.
   */
  public function testNode() {
    // Create node.
    $node = $this->drupalCreateNode(['type' => 'yamlform']);

    // Test contact form.
    $node->field_yamlform->target_id = 'contact';
    $node->save();
    $this->drupalGet('node/' . $node->id());
    $this->assertRaw('yamlform-submission-contact-form');

    // Test confirmation inline form.
    $node->field_yamlform->target_id = 'test_confirmation_inline';
    $node->save();
    $this->drupalPostForm('node/' . $node->id(), [], t('Submit'));
    $this->assertRaw('This is a custom inline confirmation message.');
  }

}
