<?php

/**
 * @file
 * Contains \Drupal\yamlform\YamlFormEntityAccessControlHandler.
 */

namespace Drupal\yamlform;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\yamlform\Access\YamlFormAccess;

/**
 * Defines the access control handler for the YAML form entity type.
 *
 * @see \Drupal\yamlform\Entity\YamlForm.
 */
class YamlFormEntityAccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  public function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    if ($operation == 'view') {
      return AccessResult::allowedIf(YamlFormAccess::checkAdminAccess($account) || $account->hasPermission('access yamlform'))->cachePerPermissions();
    }

    return parent::checkAccess($entity, $operation, $account);
  }

}
