<?php

/**
 * @file
 * Contains \Drupal\yamlform\YamlFormSubmissionAccessControlHandler.
 */

namespace Drupal\yamlform;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * Defines the access control handler for the YAML form submission entity type.
 *
 * @see \Drupal\yamlform\Entity\YamlFormSubmission.
 */
class YamlFormSubmissionAccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  public function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    return AccessResult::allowedIf($account->hasPermission('administer yamlform') || $account->hasPermission('administer yamlform submission'))->cachePerPermissions();
  }

}
